#include <iostream>
#include <cmath>
using namespace std;

int main(int argc, const char * argv[]) {

    int price = 0;
    int centerNum = 0;
    int storeNum = 0;
    int cost = 0;


    cin >> centerNum >> storeNum >> price >> cost;

    int demandList[1000] = {0};
    int storeList[1000][2] = {0};

    int storageList[10] = {0};
    int centerList[10][2] = {0};

    int distanceList[10][1000] = {0};
    int distribution[10][1000] = {0};


    for (int i = 0; i < centerNum; i++){
        cin >> centerList[i][0] >> centerList[i][1];
    }
    for (int i = 0; i < storeNum; i++){
        cin >> storeList[i][0] >> storeList[i][1];
    }
    for (int i = 0; i < storeNum; i++){
        cin >> demandList[i];
    }
    for (int i = 0; i < centerNum; i++){
        cin >> storageList[i];
    }

    for (int i = 0; i < centerNum; i++){
    	for (int j = 0; j < storeNum; j++){
    		int newDistance = abs(centerList[i][0] - storeList[j][0]) + abs(centerList[i][1] - storeList[j][1]);
    		if (price - cost*newDistance > 0)
    			distanceList[i][j] = newDistance;
    		else
    			distanceList[i][j] = -1;
    	}
    }

    while(true){
    	int nearestCenter = -1;
    	int nearestStore = -1;
    	int smallestDistance = 401;
    	for (int j = 0; j < storeNum; j++){
    		if (demandList[j] > 0){

    			int storeNearestCenter = -1;
    			int storeSmallestDistance = 401;

	    		for (int i = 0; i < centerNum; i++){

	    			if (storageList[i] > 0){
		    			if (distanceList[i][j] >= 0){
		    				if (distanceList[i][j] < storeSmallestDistance){
	    						storeNearestCenter = i;
	    						storeSmallestDistance = distanceList[i][j];
		    				}else if (distanceList[i][j] == storeSmallestDistance){
		    					if (storageList[i] > storageList[storeNearestCenter])
		    						storeNearestCenter = i;
		    				}
		    			}
	    			}	
	    		}

	    		if (storeNearestCenter != -1){
	    			if (storeSmallestDistance < smallestDistance){
	    				nearestCenter = storeNearestCenter;
	    				nearestStore = j;
	    				smallestDistance = storeSmallestDistance;
	    			}else if (storeSmallestDistance == smallestDistance){
	    				if (demandList[j] > demandList[nearestStore]){
	    					nearestCenter = storeNearestCenter;
	    					nearestStore = j;
	    				}
	    			}
	    		}


    		}

    	}

    	if (nearestCenter == -1){
    		break;
    	}else{
    		int distributionNum = min(demandList[nearestStore], storageList[nearestCenter]);
    		distribution[nearestCenter][nearestStore] = distributionNum;
    		storageList[nearestCenter] -= distributionNum;
    		demandList[nearestStore] -= distributionNum;
    	}
    }

    int totalProfit = 0;
    int unSatifiedDemand = 0;

    for (int i = 0; i < centerNum; i++){
    	for (int j = 0; j < storeNum; j++){
    		totalProfit += (price - distanceList[i][j]*cost) * distribution[i][j];
    	}
    }

    for (int i = 0; i < storeNum; i++){
    	unSatifiedDemand += demandList[i];
    }

    
    cout << totalProfit << " " << unSatifiedDemand << '\n';
    return 0;
}
