#include <iostream>
using namespace std;

void setTransactions(int**, int*, int m);
void countSupport(int**, int*, int*, int, int, int*, int);
bool isSupport(int*, int*, int, int);
bool inArray(int*, int, int);

int main(){
     
    int n = 0;
    int validCount = 0;
    int iterNum = 0;
    int located = 0 ;
    int m = 0;
    float s;

    int a = 0;
    cin >> n >> m >> s;
    int** trans = new int*[m];
    int* itemCnt = new int[m];
    int* countList = new int[n+1];

    for (int i = 0; i < n+1; i++)
        countList[i] = 0;
    
    setTransactions(trans, itemCnt, m);
    
     
    cin >> iterNum;
    int* test = new int[iterNum];
     
    // take testing data
    for(int j = 0; j < iterNum; j++){
        cin >> test[j];
    }
    countSupport(trans, test, itemCnt, m, iterNum, countList, n);
    // calculate confidence with threshold of suppport
     
    int maxIndex = -1;
    int maxCount = -1;
    for(int i = 0; i < n; i++){
        if (countList[i] > maxCount){
            maxCount = countList[i];
            maxIndex = i;
        }
    }
    if(maxCount > m*s){
        cout << (maxIndex + 1) << " " << maxCount << " " << countList[n] << endl;
    }
 
    return 0;
}


void setTransactions(int** trans , int* itemCnt , int m){

    for (int i = 0; i < m; i++){
        int num = 0;
        cin >> num;
        itemCnt[i] = num;
        int* transaction = new int[num];
        for (int j = 0; j < num; j++)
            cin >> transaction[j];
        trans[i] = transaction;
    }
};

void countSupport(int** trans, int* test, int*itemCnt, int m, int iterNum, int* countList, int n){
    for (int i = 0; i < m; i++){
        if (isSupport(trans[i], test, itemCnt[i], iterNum)){
            for (int j = 1; j <= n; j++){
                if (!inArray(test, j, iterNum) && inArray(trans[i], j, itemCnt[i])){
                    countList[j-1] += 1;
                }
            }
            countList[n] += 1;
        }
    }
};

bool isSupport(int* transaction, int* test, int m, int iterNum){
    if (m < iterNum)
        return false;
    else{
        for (int i = 0; i < iterNum; i++){
            if (!inArray(transaction, test[i], m))
                return false;
        }
    }
    return true;
}

bool inArray(int* test, int target, int length){
    for(int i = 0; i < length; i++){
        if (test[i] == target)
            return true;
    } 
    return false;
};


